package org.gamelet.middleware.midlet;

import javax.microedition.midlet.MIDlet;
import javax.microedition.midlet.MIDletStateChangeException;


public abstract class Gamelet extends MIDlet{

	public Gamelet() {
		super();
	}

	protected void destroyApp(
	    boolean arg0) throws MIDletStateChangeException
	{}

	protected void pauseApp() {}

	protected void startApp() throws MIDletStateChangeException {}

	protected abstract void initAll();

	protected abstract void initCommand();

	protected abstract  void initCanvas();

	/**
	 * Midletをシャットダウンします。
	 * @param unconditional
	 */
	public void shutdown(boolean unconditional) {
		try {
			destroyApp(unconditional);
		} catch ( MIDletStateChangeException e ) {
			System.out.println(e.getMessage( ));
		}
		if(!unconditional){
			notifyDestroyed( );
		}
	}

	/**
	 * jadに記述されたユーザー定義プロパティを解析します。
	 * 標準では何もしません。必要なときのみオーバーライドして下さい。
	 *
	 */
	public void propertyAnalyze() {}
}
